import matplotlib.pyplot as plt
import matplotlib.patches as mpatches
import itertools
import random
import copy

class sharing:
    def __init__(self, width, height, tasse, hotel):
        self.width = width 
        self.height = height
        self.tasse = tasse
        
        self.hotel = hotel
        self.beds = {}
   
        self.beta = random.random()

    

    def populate(self):
        self.available_beds = list(itertools.product(range(self.width),range(self.height)))
        random.shuffle(self.available_beds)
                               
        lista_hotel = []
        prezzo_hotel = random.randint(1,10)

        for x in range(self.hotel):
            lista_intermedia = [prezzo_hotel, 0, 'hotel']
            lista_hotel.append(lista_intermedia)
        
 
        costi_individuali = []
        while len(costi_individuali) < self.width*self.height-self.hotel:
            numero = random.randint(1,10)
            costi_individuali.append(numero)
       
        valori = []
        while len(valori) < self.width*self.height-self.hotel:
            numero = random.randint(1,10)
            valori.append(numero)
 
        attributi = []
        for x in range(self.width*self.height-self.hotel):
            lista_intermedia = [] 
            lista_intermedia.append(costi_individuali[x])
            lista_intermedia.append(valori[x])
            lista_intermedia.append('letto')
            attributi.append(lista_intermedia)
 
        
 
        j = 0
        posizione_hotel = []
        while j in range(len(lista_hotel)) and j < self.width:
            i = 0
            numero = (i, j)
 
            while i in range(len(lista_hotel)) and i < self.height:
                numero = (i, j)
                posizione_hotel.append(numero)
                i = i +1
            j += 1            
 

        i = 0
        while i in range(len(lista_hotel)):
            aggiungo_hotel = lista_hotel[i]
            posto_hotel = posizione_hotel[i]
            self.beds[posto_hotel] = aggiungo_hotel
            i = i+1
               
 
        
        y = 0
        x = 0        
        while y in range(len(attributi)):
            while x in range(len(self.available_beds)):
                verifico = self.available_beds[x]
                if verifico not in self.beds.keys():
                    aggiungo_casa = attributi[y]
                    self.beds[verifico] = aggiungo_casa
                    break
                x = x + 1
            y = y + 1
            
        
      
      
        print self.beta
        for x in self.beds.values():
            
            profit_host = x[0] - x[1] - self.tasse
            profit_rent = int(self.beta*x[0]) - self.tasse
            
            if profit_host > profit_rent and x[2] == 'letto':
                x[2] = 'host'
                
                
            elif profit_rent > 0 and x[2] == 'letto':
                x[2] = 'rent'
            
                
            elif x[2] == 'letto':
                x[2] = 'empty'
                
      
    def beta(self):
        return self.beta
        
        
        
    
    def plot(self, title, file_name):
            fig, ax = plt.subplots()
    #If you want to run the simulation with more than 7 colors, you should set agent_colors accordingly
            agent_colors = {'host':'b', 'rent':'r', 'hotel':'g', 4:'c', 5:'m', 6:'y', 7:'k'}


            def colore(x):
                agente = self.beds[agent]
                attributo = agente[2]
                return agent_colors[attributo]
            
            for agent in self.beds:
                agente = self.beds[agent]
                empty = agente[2]
                if empty != 'empty':
                    ax.scatter(agent[0]+0.5, agent[1]+0.5, color=colore(agent))

           
            ax.set_title(title, fontsize=10, fontweight='bold')
            ax.set_xlim([0, self.width])
            ax.set_ylim([0, self.height])
            ax.set_xticks([])
            ax.set_yticks([])
            red_patch = mpatches.Patch(color='red', label='rent')
            blue_patch = mpatches.Patch(color='blue', label='host')
            green_patch = mpatches.Patch(color='green', label='hotel')
            ax.legend(handles=[red_patch, blue_patch, green_patch], bbox_to_anchor=(0., 0., 0.6,0), mode="expand", ncol=3, fontsize='small', borderaxespad=0)
            
           
            plt.savefig(file_name)


