import matplotlib.pyplot as plt
import matplotlib.patches as mpatches
import itertools
import random
import copy
from operator import itemgetter

class guest:
    def __init__(self, guest_width, guest_height):
        self.guest_width = guest_width 
        self.guest_height = guest_height
        self.quota = random.random()
        self.guest = {}
        
    
        
    def populate(self):
        self.guest = list(itertools.product(range(self.guest_width),range(self.guest_height)))
        random.shuffle(self.guest)
        
        prezzi = []
        for x in range(self.guest_width*self.guest_height):
            numero = random.randint(1,10)
            prezzi.append(numero)
       
        prezzi_guest = []
        for x in prezzi:
            attributi = [x]
            prezzi_guest.append(attributi)
            
        
        quota = int(self.quota*len(prezzi_guest))
        print quota
        
        for x in prezzi_guest[:quota]:
            preferenza = 'hotel_pref'
            x.append(preferenza)
        for x in prezzi_guest[quota:]:
                preferenza = 'SE_pref'
                x.append(preferenza)
        
        self.prezzi = dict(zip(self.guest, prezzi_guest))
        return quota
        print self.prezzi
        
    def quota():
        return self.quota
        
    def plot1(self):
        i=0
        y =[]
        while i< len(self.prezzi):
            y.append(self.prezzi.values()[i][0])
            i+=1
        x= range(len(self.prezzi))
        prezzi = sorted(y)
        plt.plot(x,prezzi, 'cd')
        plt.xlim(0, self.guest_width*self.guest_height)
        plt.ylim(0, 11)
        plt.savefig('private beds distribution with guests')
            
    def plot(self, title, file_name):
            fig, ax = plt.subplots()
    #If you want to run the simulation with more than 7 colors, you should set agent_colors accordingly
            agent_colors = {'host':'b', 'rent':'r', 'empty':'g', 'guest':'c', 'hotel_pref':'m', 'SE_pref':'y', 7:'k'}

            def colore(x):
                agente = self.prezzi[agent]
                attributo = agente[1]
                return agent_colors[attributo]

            for agent in self.prezzi:
                ax.scatter(agent[0]+0.5, agent[1]+0.5, color=colore(agent))
           
            ax.set_title(title, fontsize=10, fontweight='bold')
            ax.set_xlim([0, self.guest_width])
            ax.set_ylim([0, self.guest_height])
            ax.set_xticks([])
            ax.set_yticks([])
            yellow_patch = mpatches.Patch(color='yellow', label='host pref')
            magenta_patch = mpatches.Patch(color='magenta', label='hotel pref')
            ax.legend(handles=[yellow_patch, magenta_patch], bbox_to_anchor=(0., 0., 0.6,0), mode="expand", ncol=3, fontsize='small', borderaxespad=0)
            plt.savefig(file_name)




